using System;
using System.Runtime.Serialization;
using Agile.Common;

namespace Agile.Genie.Descriptors
{
    /// <summary>
    /// Exceptions specific to the Descriptors
    /// </summary>
    [Serializable]
    public class DescriptorsException : AgileCommonException
    {
        /// <summary>
        /// Initializes a new instance of the DescriptorsException class.
        /// </summary>
        public DescriptorsException()
        {
        }

        /// <summary>
        /// Initializes a new instance of the DescriptorsException class with a specified error message. 
        /// </summary>
        /// <param name="message">A message that describes the error.</param>
        public DescriptorsException(string message) : base(message)
        {
        }

        /// <summary>
        /// Initializes a new instance of the DescriptorsException class with a specified error message and a reference to the inner exception that is the cause of this exception.  
        /// </summary>
        /// <param name="message">A message that describes the error.</param>
        /// <param name="innerException">The exception that is the cause of the current exception. 
        /// If the innerException parameter is not a null reference, 
        /// the current exception is raised in a catch block that handles the inner exception.</param>
        public DescriptorsException(string message, Exception innerException) : base(message, innerException)
        {
        }

        /// <summary>
        /// Initializes a new instance of the DescriptorsException class with serialized data.
        /// </summary>
        /// <param name="info">The object that holds the serialized object data.</param>
        /// <param name="context">The contextual information about the source or destination.</param>
        protected DescriptorsException(SerializationInfo info, StreamingContext context) : base(info, context)
        {
        }
    }
}