namespace Agile.Genie.Descriptors
{
    using System;
    using System.Runtime.Serialization;

    /// <summary>
    /// Exceptions specific to the StoredProcedureParameters
    /// </summary>
    [Serializable]
    public class StoredProcedureParametersException : DescriptorsException
    {
        /// <summary>
        /// Initializes a new instance of the StoredProcedureParametersException class.
        /// </summary>
        public StoredProcedureParametersException() : base()
        {}

        /// <summary>
        /// Initializes a new instance of the StoredProcedureParametersException class with a specified error message. 
        /// </summary>
        /// <param name="message">A message that describes the error.</param>
        public StoredProcedureParametersException(string message) : base(message)
        {}

        /// <summary>
        /// Initializes a new instance of the StoredProcedureParametersException class with a specified error message and a reference to the inner exception that is the cause of this exception.  
        /// </summary>
        /// <param name="message">A message that describes the error.</param>
        /// <param name="innerException">The exception that is the cause of the current exception. 
        /// If the innerException parameter is not a null reference, 
        /// the current exception is raised in a catch block that handles the inner exception.</param>
        public StoredProcedureParametersException(string message, Exception innerException) : base(message, innerException)
        {}

        /// <summary>
        /// Initializes a new instance of the StoredProcedureParametersException class with serialized data.
        /// </summary>
        /// <param name="info">The object that holds the serialized object data.</param>
        /// <param name="context">The contextual information about the source or destination.</param>
        protected StoredProcedureParametersException(SerializationInfo info, StreamingContext context) : base(info, context)
        {}

    }
}